//---------------------------------------------------------------------------

#ifndef sys_splashH
#define sys_splashH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <forms.hpp>
//---------------------------------------------------------------------------

void FormRegion(HWND Handle, Graphics::TBitmap* Bitmap, TColor TransparentColor, int Range);

//---------------------------------------------------------------------------

template <class T>
class splashImpl : public TThread
{
private:
	AnsiString pid_;
	T* form_;
	int sl_interval_;
	HANDLE handle_;
	void __fastcall ShowForm(){form_->Show();form_->Refresh();}
	void __fastcall CloseForm(){form_->Close();}
protected:
	void __fastcall Execute()
	{
		Synchronize(ShowForm);
		if(sl_interval_!=0&&sl_interval_!=-1)
			Sleep(sl_interval_);
		while(!Application)
			Sleep(100);
		while(!Application->MainForm)
			Sleep(100);
		while(Application->MainForm->Visible==false)
			Sleep(100);
		if(sl_interval_==-1)
		{
			HANDLE h = OpenMutex(MUTEX_ALL_ACCESS,TRUE,pid_.c_str());
			WaitForSingleObject(h,INFINITE);
		}
		Synchronize(CloseForm);
	}
public:
	__fastcall splashImpl(int sl,AnsiString p):TThread(False),sl_interval_(sl),pid_(p)
	{
		form_ = new T(NULL);
		handle_ = CreateMutex(NULL,TRUE,pid_.c_str());
	}
	__fastcall ~splashImpl()
	{
		ReleaseMutex(handle_);
		CloseHandle(handle_);
		delete form_;
	}
	T* get(){return form_;}
};

//---------------------------------------------------------------------------

void close_splash(AnsiString t="")
{
	static AnsiString id("");
	if(id=="")
	{
		id=t;
		return;
	}
	HANDLE handle_ = OpenMutex(MUTEX_ALL_ACCESS,TRUE,id.c_str());
	ReleaseMutex(handle_);
	CloseHandle(handle_);
};

//---------------------------------------------------------------------------

template <class T>
class splash
{
private:
	splashImpl<T> *impl_;
	splash();
public:
	splash(int sl,AnsiString pid="sys_unknown")
	{
		impl_ = new splashImpl<T>(sl,pid+"_splash");
		close_splash(pid+"_splash");
	}
	~splash(){delete impl_;}
	T* operator()(){return impl_->get();}
};

//---------------------------------------------------------------------------
#endif
 